ECHO off
REM Sol-Ring.bat
REM Made by JackDole
REM 2016.07.28 12:13:22

SET TidalLocked=//TidalLocked     true
SET daysYear=365.24218985
SET collectors=120
SET coldivisor=1
Set defPeriod=0
Set radius=0
Set mCM3=0.0000000000001
Set defInc=0
Set angle=0

SET DiffMap=DiffMap        "Dyson/Collector.*"
SET Disc=Collector
SET Object=Asteroid
SET Class=Asteroid

SET mSol=1.9891e+030
SET AU=149597870.691

SET NoClouds=true
SET NoOcean=true
SET NoLava=true
SET NoAtmosphere=true
SET NoAurora=true
SET NoRings=true
SET NoCometTail=true

:Sol
REM Name of the barycenter
ECHO SOL
SET Dyson=Sol
SET FileName=SolRing
SET /a DistKm=0
SET Albedo=0.1
SET Color=(0.0 0.0 0.1)
SET Mass1=%mSol%


:filehead
ECHO.// -*- coding: utf-8 -*- >%FileName%.sc
ECHO.// %FileName%.sc >>%FileName%.sc
ECHO.// Made by JackDole >>%FileName%.sc
Echo.// Date: %date% %time%>%FileName%.sc
ECHO. >>%FileName%.sc

SET numb=1
IF %angle% EQU 0 (
	Lua lcalc.lua 360/%collectors% > result.txt
	SET /p angle= < result.txt
)
SET idx=1
SET dots=.
SET distOff=3.34229356e-008

SET a=1.2

If %DistKm% EQU 0 GOTO skipKmAU
	Lua lcalc.lua %DistKm%/%AU% > result.txt
	SET /p a= < result.txt
:skipKmAU
Set aReal=%a%

If %radius% GTR 0 Goto skipRad
	Lua lcalc.lua int(3.12*%a%*%AU%/120) > result.txt
	SET /p radius= < result.txt
:skipRad

Lua lcalc.lua 1-(Ceiling(%radius%/5000000)/%radius%) > result.txt
SET /p oblateness= < result.txt

SET pi=3.14159265
SET mEarth=5.9736e24
Lua lcalc.lua (4/3*%pi%*(%radius%*1000*100)^^3*(1-%oblateness%)*%mCM3%) > result.txt
SET /p Mass2= < result.txt
Lua lcalc.lua %Mass2%/%mEarth% > result.txt
SET /p mass= < result.txt

:start
SET oW=90
SET eW=90
SET e=0.0
SET /a i=%defInc%
If /i "%FileName%" EQU "EarthRing45" SET i=45
SET /a eqnode=%eW%
Lua lcalc.lua Mod(%ow%+%i%,360) > result.txt
SET /p Obliqu= < result.txt
SET /a ML=0
SET /a peri=0
SET /a M=0
Set /a node=0

Lua lcalc.lua sqrt(%a%^^3/(%Mass1%/%mSol%+%Mass2%/%mSol%)) > result.txt
SET /p Period= < result.txt
If %defPeriod% NEQ 0 Set Period=%defPeriod%
SET orbPeriod=%Period%
Set prePeriod=%Period%
Lua lcalc.lua %Period%*%daysYear%*24 > result.txt
SET /p rotPeriod= < result.txt
SET /a rotOffset=0

SET loop=0
SET /a lend=%collectors%/%coldivisor%

SET x=1
Lua lcalc.lua Mod((%ow%+%i%)*%x%,360) > result.txt
SET /p Obliqu= < result.txt

:loop
If /i %loop% EQU %lend% GOTO ende

:file
ECHO.%Object%	"%Disc% %numb%" >>%FileName%.sc
ECHO.{ >>%FileName%.sc
ECHO.	ParentBody     "%Dyson%" >>%FileName%.sc
ECHO.	Class	       "%Class%" >>%FileName%.sc
ECHO.	>>%FileName%.sc
ECHO.	Radius          %radius% >>%FileName%.sc
ECHO.	Mass            %mass% >>%FileName%.sc
ECHO.	Oblateness      %oblateness% >>%FileName%.sc
ECHO.	Obliquity       %Obliqu% >>%FileName%.sc
ECHO.	EqAscendNode    %eqnode% >>%FileName%.sc
ECHO.	RotationPeriod  %rotPeriod% >>%FileName%.sc
ECHO.	Precession      -%prePeriod% >>%FileName%.sc
ECHO.	RotationOffset  %M%	//%rotOffset% >>%FileName%.sc

ECHO.	 >>%FileName%.sc
ECHO.	Albedo          %Albedo% >>%FileName%.sc
ECHO.	Color           %Color% >>%FileName%.sc
ECHO.	//Age             0.001 >>%FileName%.sc
ECHO.	>>%FileName%.sc

ECHO.	Surface >>%FileName%.sc
ECHO.	{ >>%FileName%.sc
ECHO.		%TidalLocked% >>%FileName%.sc
ECHO.		%DiffMap% >>%FileName%.sc
ECHO.	} >>%FileName%.sc
ECHO.	>>%FileName%.sc

ECHO.	NoClouds        %NoClouds% >>%FileName%.sc
ECHO.	NoOcean         %NoOcean% >>%FileName%.sc
ECHO.	NoLava          %NoLava% >>%FileName%.sc
ECHO.	NoAtmosphere    %NoAtmosphere% >>%FileName%.sc
ECHO.	NoAurora        %NoAurora% >>%FileName%.sc
ECHO.	NoRings         %NoRings% >>%FileName%.sc
ECHO.	NoCometTail     %NoCometTail% >>%FileName%.sc
ECHO.	>>%FileName%.sc

ECHO.	Orbit >>%FileName%.sc
ECHO.	{ >>%FileName%.sc
ECHO.		SemiMajorAxis   %a% >>%FileName%.sc
ECHO.		Period          %orbPeriod%	// Jahre >>%FileName%.sc
ECHO.		Eccentricity    %e% >>%FileName%.sc
ECHO.		Inclination     %i% >>%FileName%.sc
ECHO.		//AscendingNode   %node% >>%FileName%.sc
ECHO.		//ArgOfPericenter %peri% >>%FileName%.sc
ECHO.		MeanAnomaly     %M% >>%FileName%.sc
ECHO.		MeanLongitude	%M%	//%ML% >>%FileName%.sc
REM ECHO.		RefPlane       "Equator" >>%FileName%.sc
ECHO.		RefPlane       "Ecliptic" >>%FileName%.sc
ECHO.	} >>%FileName%.sc
ECHO.} >>%FileName%.sc
ECHO. >>%FileName%.sc

Lua lcalc.lua %M%+%angle% > result.txt
SET /p M= < result.txt
Lua lcalc.lua Mod(%M%+%eW%,360) > result.txt
SET /p eqnode= < result.txt

SET /a loop=%loop%+1
SET /a numb=%numb%+1

SET dots=%dots%.
SET /a idx=%idx%+1
If %idx% EQU 10 (
	ECHO %dots%
	SET dots=.
	SET idx=1
)

GOTO loop

:ende
ECHO %dots%
ECHO Fertig.

